# modules defaults
%define modulefile_path_top /opt/share/Modules/modulefiles/nvhpc

Version:	24.11
%define nversion %(echo %{version} | tr . -)
Name:		pu-nvhpc-%{nversion}
Release:	7%{?dist}.2
Summary:	PU Wrapper for Nvidia HPC
Group:		Development/Libraries
License:	Other
Requires:	environment-modules
%if %{rhel} > 7
Requires:	environment-modules-local
%endif
Requires:	nvhpc-%{nversion}
#Requires:	nvhpc-%{nversion}-cuda-multi
Requires:	hardlink
Provides:	libacchost.so()(64bit)
Provides:	libnvcpumath.so()(64bit)
Provides:	libnvc.so()(64bit)
Provides:	libnvomp.so(VERSION)(64bit)
Provides:	libnvomp.so()(64bit)
Provides:	libnvf.so()(64bit)
Provides:	libnvhpcatm.so()(64bit)
Provides:	libnvcpumath.so(LIBNVCPUMATH_VERSION)(64bit)
Provides:	pu-nvhpc = %{version}-%{release}

%description
Wrapper for NVIDIA HPC Tools

%prep

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{modulefile_path_top}
mkdir -p $RPM_BUILD_ROOT/%{modulefile_path_top}-hpcx
mkdir -p $RPM_BUILD_ROOT/%{modulefile_path_top}-hpcx-cuda12
mkdir -p $RPM_BUILD_ROOT/%{modulefile_path_top}-nocompiler
cat <<ENDCOREMODULE > ${RPM_BUILD_ROOT}%{modulefile_path_top}/%{version}
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# %{name} rpm).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds NVidia HPC %{version} to various paths"
}

module-whatis   "Sets up %{name} %{version} in your environment"

conflict nvhpc
conflict nvhpc-hpcx
conflict nvhpc-nocompiler

set nvhome /opt/nvidia/hpc_sdk
set target Linux_%{_arch}
set version %{version}

set nvcudadir \$nvhome/\$target/\$version/cuda
set nvcompdir \$nvhome/\$target/\$version/compilers
set nvmathdir \$nvhome/\$target/\$version/math_libs
set nvcommdir \$nvhome/\$target/\$version/comm_libs

setenv NVHPC \$nvhome
setenv NVHPC_ROOT \$nvhome/\$target/\$version
setenv CC \$nvcompdir/bin/nvc
setenv CXX \$nvcompdir/bin/nvc++
setenv FC \$nvcompdir/bin/nvfortran
setenv F90 \$nvcompdir/bin/nvfortran
setenv F77 \$nvcompdir/bin/nvfortran
setenv CPP cpp

prepend-path PATH \$nvcudadir/bin
prepend-path PATH \$nvcompdir/bin
prepend-path PATH \$nvcompdir/extras/qd/bin

prepend-path LD_LIBRARY_PATH \$nvcudadir/lib64
prepend-path LD_LIBRARY_PATH \$nvcompdir/extras/qd/lib
prepend-path LD_LIBRARY_PATH \$nvcompdir/lib
prepend-path LD_LIBRARY_PATH \$nvmathdir/lib64
prepend-path LD_LIBRARY_PATH \$nvcommdir/nccl/lib
prepend-path LD_LIBRARY_PATH \$nvcommdir/nvshmem/lib

prepend-path CPATH \$nvmathdir/include
prepend-path CPATH \$nvcommdir/nccl/include
prepend-path CPATH \$nvcommdir/nvshmem/include
prepend-path CPATH \$nvcompdir/extras/qd/include/qd

prepend-path C_INCLUDE_PATH \$nvmathdir/include
prepend-path C_INCLUDE_PATH \$nvcommdir/nccl/include
prepend-path C_INCLUDE_PATH \$nvcommdir/nvshmem/include
prepend-path C_INCLUDE_PATH \$nvcompdir/extras/qd/include/qd

prepend-path CPLUS_INCLUDE_PATH \$nvmathdir/include
prepend-path CPLUS_INCLUDE_PATH \$nvcommdir/nccl/include
prepend-path CPLUS_INCLUDE_PATH \$nvcommdir/nvshmem/include
prepend-path CPLUS_INCLUDE_PATH \$nvcompdir/extras/qd/include/qd

prepend-path MANPATH \$nvcompdir/man
ENDCOREMODULE

cat <<ENDHPCXMODULE > ${RPM_BUILD_ROOT}%{modulefile_path_top}-hpcx/%{version}
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# %{name} rpm).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds NVidia HPC %{version} with HPCX to various paths"
}

module-whatis   "Sets up %{name} with HPCX %{version} in your environment"

conflict nvhpc
conflict nvhpc-hpcx
conflict nvhpc-nocompiler

set nvhome /opt/nvidia/hpc_sdk
set target Linux_%{_arch}
set version %{version}
set cudaver trampoline

set nvcudadir \$nvhome/\$target/\$version/cuda
set nvcompdir \$nvhome/\$target/\$version/compilers
set nvmathdir \$nvhome/\$target/\$version/math_libs
set nvcommdir \$nvhome/\$target/\$version/comm_libs

setenv NVHPC \$nvhome
setenv NVHPC_ROOT \$nvhome/\$target/\$version
setenv CC \$nvcompdir/bin/nvc
setenv CXX \$nvcompdir/bin/nvc++
setenv FC \$nvcompdir/bin/nvfortran
setenv F90 \$nvcompdir/bin/nvfortran
setenv F77 \$nvcompdir/bin/nvfortran
setenv CPP cpp

prepend-path PATH \$nvcudadir/bin
prepend-path PATH \$nvcompdir/bin
prepend-path PATH \$nvcompdir/extras/qd/bin

prepend-path LD_LIBRARY_PATH \$nvcudadir/lib64
prepend-path LD_LIBRARY_PATH \$nvcompdir/extras/qd/lib
prepend-path LD_LIBRARY_PATH \$nvcompdir/lib
prepend-path LD_LIBRARY_PATH \$nvmathdir/lib64
prepend-path LD_LIBRARY_PATH \$nvcommdir/nccl/lib
prepend-path LD_LIBRARY_PATH \$nvcommdir/nvshmem/lib

prepend-path CPATH \$nvmathdir/include
prepend-path CPATH \$nvcommdir/nccl/include
prepend-path CPATH \$nvcommdir/nvshmem/include
prepend-path CPATH \$nvcompdir/extras/qd/include/qd

prepend-path C_INCLUDE_PATH \$nvmathdir/include
prepend-path C_INCLUDE_PATH \$nvcommdir/nccl/include
prepend-path C_INCLUDE_PATH \$nvcommdir/nvshmem/include
prepend-path C_INCLUDE_PATH \$nvcompdir/extras/qd/include/qd

prepend-path CPLUS_INCLUDE_PATH \$nvmathdir/include
prepend-path CPLUS_INCLUDE_PATH \$nvcommdir/nccl/include
prepend-path CPLUS_INCLUDE_PATH \$nvcommdir/nvshmem/include
prepend-path CPLUS_INCLUDE_PATH \$nvcompdir/extras/qd/include/qd
prepend-path PATH ]$nvcommdir/hpcx/bin

ENDHPCXMODULE

cat <<ENDHPCXCUDAMODULE > ${RPM_BUILD_ROOT}%{modulefile_path_top}-hpcx-cuda12/%{version}
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# %{name} rpm).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds NVidia HPC %{version} with HPCX for cuda 12.4 to various paths"
}

module-whatis   "Sets up %{name} with HPCX %{version} for cuda 12.4 in your environment"

conflict nvhpc
conflict nvhpc-hpcx
conflict nvhpc-nocompiler

set nvhome /opt/nvidia/hpc_sdk
set target Linux_%{_arch}
set version %{version}
set cudaver 12.6

set nvcudadir \$nvhome/\$target/\$version/cuda
set nvcompdir \$nvhome/\$target/\$version/compilers
set nvmathdir \$nvhome/\$target/\$version/math_libs
set nvcommdir \$nvhome/\$target/\$version/comm_libs

setenv NVHPC \$nvhome
setenv NVHPC_ROOT \$nvhome/\$target/\$version
setenv CC \$nvcompdir/bin/nvc
setenv CXX \$nvcompdir/bin/nvc++
setenv FC \$nvcompdir/bin/nvfortran
setenv F90 \$nvcompdir/bin/nvfortran
setenv F77 \$nvcompdir/bin/nvfortran
setenv CPP cpp

prepend-path PATH \$nvcudadir/bin
prepend-path PATH \$nvcompdir/bin
prepend-path PATH \$nvcompdir/extras/qd/bin

prepend-path LD_LIBRARY_PATH \$nvcudadir/lib64
prepend-path LD_LIBRARY_PATH \$nvcompdir/extras/qd/lib
prepend-path LD_LIBRARY_PATH \$nvcompdir/lib
prepend-path LD_LIBRARY_PATH \$nvmathdir/lib64
prepend-path LD_LIBRARY_PATH \$nvcommdir/nccl/lib
prepend-path LD_LIBRARY_PATH \$nvcommdir/nvshmem/lib

prepend-path CPATH \$nvmathdir/include
prepend-path CPATH \$nvcommdir/nccl/include
prepend-path CPATH \$nvcommdir/nvshmem/include
prepend-path CPATH \$nvcompdir/extras/qd/include/qd

prepend-path C_INCLUDE_PATH \$nvmathdir/include
prepend-path C_INCLUDE_PATH \$nvcommdir/nccl/include
prepend-path C_INCLUDE_PATH \$nvcommdir/nvshmem/include
prepend-path C_INCLUDE_PATH \$nvcompdir/extras/qd/include/qd

prepend-path CPLUS_INCLUDE_PATH \$nvmathdir/include
prepend-path CPLUS_INCLUDE_PATH \$nvcommdir/nccl/include
prepend-path CPLUS_INCLUDE_PATH \$nvcommdir/nvshmem/include
prepend-path CPLUS_INCLUDE_PATH \$nvcompdir/extras/qd/include/qd
set hpcxmoddir \$nvcommdir/\$cudaver/hpcx/latest/modulefiles

if { [ module-info mode load ] } {
    module use \$hpcxmoddir
    module load hpcx
}

ENDHPCXCUDAMODULE
cat <<ENDCOREMODULE > ${RPM_BUILD_ROOT}%{modulefile_path_top}-nocompiler/%{version}
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# %{name} rpm).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds NVidia HPC %{version} to various paths"
}

module-whatis   "Sets up %{name} %{version} in your environment"

conflict nvhpc
conflict nvhpc-hpcx
conflict nvhpc-nocompiler

set nvhome /opt/nvidia/hpc_sdk
set target Linux_%{_arch}
set version %{version}

set nvcudadir \$nvhome/\$target/\$version/cuda
set nvmathdir \$nvhome/\$target/\$version/math_libs
set nvcommdir \$nvhome/\$target/\$version/comm_libs

setenv NVHPC \$nvhome
setenv NVHPC_ROOT \$nvhome/\$target/\$version

prepend-path PATH \$nvcudadir/bin

prepend-path CPATH \$nvcudadir/include
prepend-path CPATH \$nvmathdir/include
prepend-path CPATH \$nvcommdir/nccl/include
prepend-path CPATH \$nvcommdir/nvshmem/include

prepend-path C_INCLUDE_PATH \$nvcudadir/include
prepend-path C_INCLUDE_PATH \$nvmathdir/include
prepend-path C_INCLUDE_PATH \$nvcommdir/nccl/include
prepend-path C_INCLUDE_PATH \$nvcommdir/nvshmem/include

prepend-path CPLUS_INCLUDE_PATH \$nvcudadir/include
prepend-path CPLUS_INCLUDE_PATH \$nvmathdir/include
prepend-path CPLUS_INCLUDE_PATH \$nvcommdir/nccl/include
prepend-path CPLUS_INCLUDE_PATH \$nvcommdir/nvshmem/include

prepend-path LD_LIBRARY_PATH \$nvcudadir/lib64
prepend-path LD_LIBRARY_PATH \$nvmathdir/lib64
prepend-path LD_LIBRARY_PATH \$nvcommdir/nccl/lib
prepend-path LD_LIBRARY_PATH \$nvcommdir/nvshmem/lib
ENDCOREMODULE

%post
/usr/sbin/hardlink -c /usr/local/cuda-12* /opt/nvidia/ >/dev/null 2>&1 || :

%triggerin -- cudatoolkit124 cudatoolkit124-devel cudatoolkit126 cudatoolkit126-devel
/usr/sbin/hardlink -c /usr/local/cuda-12* /opt/nvidia/ >/dev/null 2>&1 || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{modulefile_path_top}
%{modulefile_path_top}/*
%dir %{modulefile_path_top}-hpcx
%{modulefile_path_top}-hpcx/*
%dir %{modulefile_path_top}-hpcx-cuda12
%{modulefile_path_top}-hpcx-cuda12/*
%dir %{modulefile_path_top}-nocompiler
%{modulefile_path_top}-nocompiler/*

%changelog
* Mon Sep 14 2020 Josko Plazonic <plazonic@princeton.edu>
- initial
